"""
Django settings for autopodbor project.

Generated by 'django-admin startproject' using Django 1.11.

For more information on this file, see
https://docs.djangoproject.com/en/1.11/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.11/ref/settings/
"""

import os
import environ
from kombu import Queue, Exchange

# Dev key
TOKEN = "851335790:AAGBAq9xOmw5J8z2U89aKgpP4btWwwgzPv8"

# Load operating system environment variables and then prepare to use them
env = environ.Env()
AUTHENTICATION_METHOD = "API"
# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

CELERY_BROKER_URL = env('CELERY_BROKER_URL',
                        default='redis://localhost:6379/0')
CELERY_RESULT_BACKEND = env('CELERY_RESULT_BACKEND',
                            default='redis://localhost:6379/1')
CELERY_ACCEPT_CONTENT = ['application/json']
CELERY_TASK_SERIALIZER = 'json'
CELERY_RESULT_SERIALIZER = 'json'
CELERY_TIMEZONE = 'UTC'
CELERY_ENABLE_UTC = True
CELERY_BEAT_SCHEDULER = 'django_celery_beat.schedulers:DatabaseScheduler'

YANDEX_MONEY_DEBUG = False
YANDEX_MONEY_SCID = 12345
YANDEX_MONEY_SHOP_ID = 56789
YANDEX_MONEY_SHOP_PASSWORD = 'password'
YANDEX_MONEY_FAIL_URL = 'https://example.com/fail-payment/'
YANDEX_MONEY_SUCCESS_URL = 'https://example.com/success-payment/'
# информировать о случаях, когда модуль вернул Яндекс.Кассе ошибку
YANDEX_MONEY_MAIL_ADMINS_ON_PAYMENT_ERROR = True

# CELERY_QUEUES = {
#     Queue('default', Exchange('default'), routing_key='default')
# }

CELERY_DEFAULT_EXCHANGE = 'default'
CELERY_TASK_DEFAULT_QUEUE = 'default'

REDIS_CACHE_HOST = env('REDIS_CACHE_HOST', default='localhost')
REDIS_CACHE_PORT = 6379
REDIS_CACHE_DB = 3

CONSTANCE_REDIS_CONNECTION = {
    'host': env('REDIS_CACHE_HOST', default='localhost'),
    'port': 6379,
    'db': 4,
}

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.11/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '0tzb7z-t9djt_#@xjxoy@b73@x#)ce%n_nal^e_m7%j_z-o7uf'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

INTERNAL_IPS = ['127.0.0.1']
# CORS_ORIGIN_WHITELIST = (
#     '195.133.31.221'
# )
# CORS_ORIGIN_ALLOW_ALL = False
# CORS_URLS_REGEX = r'^.*$'
# CORS_ALLOW_CREDENTIALS = True
SITE_ID = 1
# CORS_ALLOW_HEADERS = (
#     'accept',
#     'authorization',
#     'content-type',
#     'If-Match',
#     'origin',
#     'x-csrftoken',
#     'x-requested-with',
#     'total-count',
#     'per-page',
#     'pages-count',
# )

# Application definition

INSTALLED_APPS = [
    'tinymce',
    'yandex_money',
    'payment_page_sdk',
    'mathfilters',
    'corsheaders',
    'safedelete',
    'admin_view_permission',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.sites',
    'django_celery_beat',
    'django.contrib.humanize',
    # 'opbeat.contrib.django',
    # 'rest_framework',
    'anymail',
    'field_history',
    'custom_admin',
    'core',
    'lk',
    'statistika',
    'auto',
    'order',
    'service',
    'report',
    'reports',
    'message',
    'notifications',
    'integration',
    'dbmail',
    'django_filters',
    'compressor',
    'jsoneditor',

    # django-allauth
    'allauth',  # registration
    'allauth.account',  # registration
    'allauth.socialaccount',  # registration

    # google_photo
    'google_photo',

]

MIDDLEWARE = [
    # 'opbeat.contrib.django.middleware.OpbeatAPMMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.security.SecurityMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware'
]

if env('USE_FIELD_HISTORY', default=True) is True:
    MIDDLEWARE += ['field_history.middleware.FieldHistoryMiddleware', ]


# OPBEAT = {
#     'ORGANIZATION_ID': '79ffda3f7d8b4758872e8b3ceccf6caf',
#     'APP_ID': 'ed0b1b76c7',
#     'SECRET_TOKEN': 'dbcbb54cb74fadf7d8bcc7ed3605577d92f72399',
#     'DEBUG': DEBUG
# }

CONSTANCE_CONFIG = {
    'THUMBNAIL_WIDTH': (150, 'Ширина миниатюр'),
    'THUMBNAIL_HEIGHT': (150, 'Высота миниатюр'),
}


ROOT_URLCONF = 'autopodbor.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, "templates")],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'lk.context_processors.common'
            ]
        },
    },
]

WSGI_APPLICATION = 'autopodbor.wsgi.application'


# Database
# https://docs.djangoproject.com/en/1.11/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'NAME': 'autopodbor',
        'USER': 'autopodbor',
        'PASSWORD': env('DJANGO_PG_PASSWORD', default='2l5g423dp5cjteO'),
        'HOST': env('DJANGO_PG_HOST', default='127.0.0.1'),
        'PORT': '5432',
    },
    'crm_db': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': 'podbor_lp',
        'USER': 'podbor_lp_usr',
        'PASSWORD': '2x0F0sGx2y3JUqd4',
        'HOST': '127.0.0.1',
        'PORT': '3307',
    },
    'lk': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': 'lk',
        'USER': 'databaseuser',
        'PASSWORD': 'mReVR82w9v7mGM6n',
        'HOST': '127.0.0.1',
        'PORT': '3307',
    }
}

ATOMIC_REQUESTS = True
DATA_UPLOAD_MAX_MEMORY_SIZE = None
DATA_UPLOAD_MAX_NUMBER_FIELDS = None

# Password validation
# https://docs.djangoproject.com/en/1.11/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
        'OPTIONS': {
            'min_length': 6,
        },
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]

AUTH_USER_MODEL = 'core.User'
# DJANGO_GROUP_MODEL = 'core.AutoPodborGroup'

# Internationalization
# https://docs.djangoproject.com/en/1.11/topics/i18n/

LANGUAGE_CODE = 'ru-ru'

#TIME_ZONE = 'UTC'
TIME_ZONE = 'Europe/Moscow'

USE_I18N = True

USE_L10N = True

USE_TZ = False


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.11/howto/static-files/

STATIC_URL = '/static/'
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static")
]
STATIC_ROOT = os.path.join(BASE_DIR, 'static_collected/')
STATICFILES_FINDERS = (
    'django.contrib.staticfiles.finders.FileSystemFinder',
    'django.contrib.staticfiles.finders.AppDirectoriesFinder',
    'compressor.finders.CompressorFinder',
)
MEDIA_URL = "/media/"
MEDIA_ROOT = os.path.join(BASE_DIR, "media")

COMPRESS_ENABLED = False
COMPRESS_OFFLINE = False

DATE_FORMAT = '%d.%m.%Y %H:%M'
DATETIME_FORMAT = '%d.%m.%y %H:%M'

LOGIN_URL = '/accounts/login/'
LOGIN_REDIRECT_URL = '/'

GROUPS_CONTROLLING_USERS = {'Администратор',
                            'Руководитель', 'Бухгалтер', 'Контент-менеджер'}

EMAIL_BACKEND = env.str('DJANGO_EMAIL_BACKEND',
                        default='django.core.mail.backends.console.EmailBackend')
DEFAULT_FROM_EMAIL = env.str(
    'DJANGO_DEFAULT_FROM_EMAIL', default='info@ap4u.ru')

ANYMAIL = {
    'MAILGUN_API_KEY': env.str('DJANGO_MAILGUN_API_KEY', default=''),
    'MAILGUN_SENDER_DOMAIN': env.str('DJANGO_MAILGUN_SENDER_DOMAIN', default=''),
}

ADMINS = (
    ('Sergey Nosachev', 'crackkc@mail.ru'),
)

ECOMMPAY_SECRET = '0f68de1ca4ce6f9ae65c362b70243a31ad07375afd6d5465271fc75176292935215daa80bfd28c4e52bfa4bffcd2ff9f48bd309797f3c68f10f2f7d6836bd89b'
ECOMMPAY_PROJECT_ID = '4911'
ECOMMPAY_REPORT_PRICE = 30000
EXECUTOR_PERSENT = 40

SMS_API_ID = '40ee7180-3189-5b14-5d61-6b19099c3a9b'
SMS_API_PASS = '0d23e0dfc409b6e0ef657958dd053f79'
SMS_API_LOGIN = '79160607020'
SMS_API_NAMING = 'auto_podbor'
ANTICAPTCHA_API = '9cc7a7d2c702b77dab4117f34693988c'

# администраторы получат емейл, если баланс на смс.ру меньше этого значения
SMS_BALANCE_FOR_NOTIFYING = 100
ANTICAPTCHA_BALANCE_FOR_NOTIFYING = 0.5

# число попыток ввода капчи при парсинге auto.ru
ATTEMPT_PARSE_COUNT = 50
CONNECT_TIMEOUT = 30
TIMEOUT = 8

TEST_RUNNER = "core.utils.NoLoggingTestRunner"

LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'formatters': {
        'verbose': {
            'format': '%(levelname)s %(asctime)s %(name)s.%(funcName)s:%(lineno)d %(message)s'
        }
    },
    'handlers': {
        'default': {
            'level': 'INFO',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'main.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose',
        },
        'sms_file': {
            'level': 'INFO',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'sms.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'notification_file': {
            'level': 'INFO',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'notifications/notification.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'integration_file': {
            'level': 'INFO',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'integration/integration.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'integration_file_error': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'integration/integration_error.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'export_mobile': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'report/workers/export_mobile.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'expert_to_crm': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'core/workers/expert_to_crm.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'status_to_crm': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'order/workers/status_to_crm.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'core_utils': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'core/core_utils.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'monitoring': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'core/workers/monitoring.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'order_forms': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'order/order_forms.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'telegrambot': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'core/telegrambot.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'load_orders_on_mobile': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'order/workers/load_orders_on_mobile.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        'core_api_views': {
            'level': 'ERROR',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': 'core/api/core_api_views.log',
            'maxBytes': 1024*1024*5,  # 5 MB
            'formatter': 'verbose'
        },
        # 'opbeat': {
        #     'level': 'WARNING',
        #     'class': 'opbeat.contrib.django.handlers.OpbeatHandler',
        # },
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'verbose'
        }
    },
    'loggers': {
        '': {
            'handlers': ['default', 'console'],  # , 'opbeat'
            'level': 'INFO',
            'propagate': True
        },
        'notifications.sms': {
            'handlers': ['sms_file'],
            'level': 'INFO',
            'propagate': False
        },
        'notifications.views': {
            'handlers': ['sms_file'],
            'level': 'INFO',
            'propagate': False
        },
        'notifications.models': {
            'handlers': ['notification_file'],
            'level': 'INFO',
            'propagate': False
        },
        'integration.views': {
            'handlers': ['integration_file'],
            'level': 'INFO',
            'propagate': False
        },
        'integration.serializers': {
            'handlers': ['integration_file'],
            'level': 'INFO',
            'propagate': False
        },
        'integration.views': {
            'handlers': ['integration_file_error'],
            'level': 'ERROR',
            'propagate': False
        },
        'integration.serializers': {
            'handlers': ['integration_file_error'],
            'level': 'ERROR',
            'propagate': False
        },
        'report.workers.export_mobile': {
            'handlers': ['export_mobile'],
            'level': 'ERROR',
            'propagate': False
        },
        'core.workers.expert_to_crm': {
            'handlers': ['expert_to_crm'],
            'level': 'ERROR',
            'propagate': False
        },
        'order.workers.send_status_to_crm': {
            'handlers': ['status_to_crm'],
            'level': 'ERROR',
            'propagate': False
        },
        'core.utils': {
            'handlers': ['core_utils'],
            'level': 'ERROR',
            'propagate': False
        },
        'core.workers.monitoring': {
            'handlers': ['monitoring'],
            'level': 'ERROR',
            'propagate': False
        },
        'order.forms': {
            'handlers': ['order_forms'],
            'level': 'ERROR',
            'propagate': False
        },
        'core.management.commands.telegrambot': {
            'handlers': ['telegrambot'],
            'level': 'ERROR',
            'propagate': False
        },
        'order.workers.export': {
            'handlers': ['load_orders_on_mobile'],
            'level': 'ERROR',
            'propagate': False
        },
        'core.api.views': {
            'handlers': ['core_api_views'],
            'level': 'ERROR',
            'propagate': False
        },
    },
}

AUTHENTICATION_BACKENDS = (
    # Needed to login by username in Django admin, regardless of `allauth`
    'django.contrib.auth.backends.ModelBackend',
    # Needed to login by phone
    'core.backend_auth.PhoneBackend',
    # `allauth` specific authentication methods, such as login by e-mail
    'allauth.account.auth_backends.AuthenticationBackend',
)

ACCOUNT_LOGOUT_ON_GET = True
ACCOUNT_EMAIL_VERIFICATION = None

ACCOUNT_FORMS = (
    {
        'signup': 'core.forms.AddUserForm',
        'login': 'core.forms.LoginForm'
    }
)

# ftp mobile
FTP_URL = "144.76.106.105"
FTP_USER = "podbororg963"
FTP_PSW = "FTuisr0MhWjuorFZ"
TIME_AFTER_LOAD = 5

# ftp backup
FTP_URL_BACKUP = "81.200.31.250"
FTP_PORT_BACKUP = "25021"
FTP_USER_BACKUP = "backup"
FTP_PSW_BACKUP = "325asetcv"


# filials
MOSKOW = 1

# paginate
PAGINATE_BY = 20

# инструкции
ADMININST = "https://docs.google.com/document/d/1w_fKniO0BD0HWifK99UxtXV53Ku5dSP8x4grAJWdSeE/edit?usp=sharing"
COMANGINST = "https://docs.google.com/document/d/1EZx9El49508R42UJpqnai-NZ_vZZ5UfdyagZwsMRW0k/edit?usp=sharing"
BUCHINST = "https://docs.google.com/document/d/1Tgz1d69Go6sErLlgPvRut5xM-EZFRl5briwvIjuuRfg/edit?usp=sharing"
EXPERTINST = "https://docs.google.com/document/d/1pL48Bkhxfv0N3x-NL9cmL2mhV7iFcRTqQ7XrlVtsnA8/edit#heading=h.v0y2w0b2r7yn"
LIEDINST = "https://docs.google.com/document/d/1m_9XeJs67PWPK6Z71E7hbCYPWXRIa8_kJp8rCfT5Lj4/edit#heading=h.v0y2w0b2r7yn"
OPERINST = "https://docs.google.com/document/d/1Mdjjp8NrTfK3f8edVsOPkrObLiKV0jrbxQlxuKOvwtw/edit?usp=sharing"
CLIENT = "https://docs.google.com/document/d/1-DcUkHZxfFTryD9xnwkUWGjBbx4JWoVqPfvuB4qOwss/edit?usp=sharing"
REST_FRAMEWORK = {
    'DATETIME_FORMAT': "%Y-%m-%dT%H:%M:%S.%fZ",
}

CUSTOM_FIELD_HISTORY = True

INTEGRATION_DEV = False
URLCRM = "https://crm.podbor.org"
TO_CRM = True
URL = "https://лк2.авто-подбор.рф"

NOT_NOTIFICATION = False

CSRF_FAILURE_VIEW = 'core.backend_auth.csrf_failure'

EXPERTTOCRM = True

# monitoring
MONITOR_PERCENT_MEMORY = 1
TESTMATCHING = False

try:
    from .local_settings import *
except ImportError:
    pass

# tor
TORRPASSWORD = "x0QMIhV4eN4TaDUocE0l__tor"

# TINYMCE_DEFAULT_CONFIG = {
#     'plugins': "table,spellchecker,paste,searchreplace",
#     'theme': "advanced",
#     'cleanup_on_startup': True,
#     'custom_undo_redo_levels': 10,
#     'width': 900,
#     'height': 450

# }
TINYMCE_DEFAULT_CONFIG = {
    'theme': "advanced",  # default value
    'relative_urls': False,  # default value
    'plugins': 'table,spellchecker,paste,searchreplace',
    'theme_advanced_buttons1': 'bold,italic,underline,bullist,numlist,link,unlink,styleselect,fontselect,fontsizeselect',
    'theme_advanced_buttons2': '',
    'theme_advanced_buttons3': '',
    'width': '100%',
    'height': 450,
    'paste_text_sticky': True,
    'paste_text_sticky_default': True,
    'valid_styles': 'font-weight,font-style,text-decoration',
    'fontsize_formats': "8pt 10pt 11pt 12pt 13pt 14pt 16pt 18pt 20pt 24pt 36pt",
    'font_formats': "Andale Mono=andale mono,times;" +
    "Arial=arial,helvetica,sans-serif;" +
    "Arial Black=arial black,avant garde;" +
    "Book Antiqua=book antiqua,palatino;" +
    "Comic Sans MS=comic sans ms,sans-serif;" +
    "Courier New=courier new,courier;" +
    "Georgia=georgia,palatino;" +
    "Helvetica=helvetica;" +
    "Impact=impact,chicago;" +
    "Symbol=symbol;" +
    "Tahoma=tahoma,arial,helvetica,sans-serif;" +
    "Terminal=terminal,monaco;" +
    "Times New Roman=times new roman,times;" +
    "Trebuchet MS=trebuchet ms,geneva;" +
    "Verdana=verdana,geneva;" +
    "Webdings=webdings;" +
    "Wingdings=wingdings,zapf dingbats",
}

ALLOWED_HOSTS = ['148.251.13.108', 'xn--2-stbc.xn----7sbecl2dbcfoo.xn--p1ai',
                 'xn--2-ctbfe.xn----7sbecl2dbcfoo.xn--p1ai', 'localhost', '127.0.0.1', '0.0.0.0']
